<template>
  <div class="content">
    <div class="section block desktopshow submenu">
      <nav-report :full="full"/>
    </div>

    <div class="section block data">
      <div
        v-if="promo"
        class="section">
        <div class="kit info text mini block color yellow">
          <p>У вас есть <span class="kit text medium">промокод</span>?
            <span class="mobilshow"><br></span>
            <a
              href="#"
              class="link"
              @click.prevent="$emit('show-purchase')">Зарегистрируйтесь при покупке</a> или
            <a
              href="#"
              class="link"
              @click.prevent="showAuthModal">авторизуйтесь</a>,
              и&nbsp;получите&nbsp;скидку!
          </p>
        </div>
      </div>
      <div class="section bordered">
        <div class="chunk fluid">
          <h2>{{ info.Brand }}, {{ info.Model }}</h2>
          <div class="kit info text medium line">
            <div class="item year-wrap">
              <span class="caption">Год производства:</span>
              <span class="value">{{ info.Year }} г.в</span>
            </div>
          </div>
        </div>
      </div>

      <div
        id="checkauto-general"
        v-if="full"
        class="section bordered">
        <div class="heading">Общая информация о ТС</div>
        <div class="chunk">
          <div class="kit info text mini line">
            <div class="item">
              <span class="caption">Категория т/с: </span>
              <span class="value">{{ info.Category|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Номер двигателя: </span>
              <span class="value">{{ info.EngineNumber|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Номер кузова: </span>
              <span class="value">{{ info.BodyNumber|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Мощность двигателя (л.с.): </span>
              <span class="value">{{ info.Power|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Номер шасси: </span>
              <span class="value">{{ info.ChassisNumber|def(noData) }}</span>
            </div>
            <div
              v-if="hasProp(info,'Price')"
              class="item">
              <span class="caption">Средняя цена авто: </span>
              <span class="value">{{ info.Price|currency }} руб.</span>
            </div>
          </div>
        </div>
        <div class="chunk">
          <div class="kit info text mini line ">
            <div
              v-if="hasProp(info,'RegNumber')"
              class="item">
              <span class="caption">Гос. номер: </span>
              <span class="value">{{ info.RegNumber }}</span>
            </div>
            <div class="item">
              <span class="caption">Объем двигателя (см.куб.): </span>
              <span class="value">{{ info.Displacement|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Тип двигателя: </span>
              <span class="value">{{ info.EngineTypeName|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Признак расположения руля: </span>
              <span class="value">{{ info.SteeringWheelPlacementName|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Разрешенная максимальная масса: </span>
              <span class="value">{{ info.MaxWeight|def(noData) }}</span>
            </div>
            <div class="item">
              <span class="caption">Масса без нагрузки: </span>
              <span class="value">{{ info.NettoWeight|def(noData) }}</span>
            </div>
          </div>
        </div>
      </div>

      <div
        id="checkauto-summary"
        class="section desktopshow">
        <div class="heading">Сводные данные</div>
        <div class="chunk">
          <div class="kit info text mini line ">
            <div class="item">
              <span class="caption">Количество рег. действий: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.registration.length > 0">{{ info.registration.length }}</template>
                  <template v-else>{{ noData }}</template>
                </template>
                <template v-else>
                  <template v-if="info.Count > 0">{{ info.Count }}</template>
                  <template v-else>{{ noData }}</template>
                </template>
              </div>
            </div>

            <div class="item">
              <span class="caption">Угон: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.Stealing">
                    <a
                      class="link"
                      href="#checkauto-hijacking">В угоне</a>
                  </template>
                  <template v-else>Не в угоне</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
            <div class="item">
              <span class="caption">Работа в такси: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.Taxi">
                    <a
                      class="link"
                      href="#checkauto-taxi">Да</a>
                  </template>
                  <template v-else>Не использовалась в такси</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
          </div>
        </div>
        <div class="chunk">
          <div class="kit info text mini line ">
            <div class="item">
              <span class="caption">Лизинг: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.Leasing">
                    <a
                      class="link"
                      href="#checkauto-leasing">В лизинге</a>
                  </template>
                  <template v-else>Не в лизинге</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
            <div class="item">
              <span class="caption">Аварии: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.dtp.loaded">
                    <template v-if="info.dtp.items.length > 0">
                      <a
                        class="link"
                        href="#checkauto-accidents">{{ info.dtp.items.length }}</a>
                    </template>
                    <template v-else>Аварий не зафиксировано в системе</template>
                  </template>
                  <template v-else>{{ noData }}</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
            <div class="item">
              <span class="caption">Утилизация: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.Utilisation">
                    <a
                      class="link"
                      href="#checkauto-recycling">Утилизировано</a>
                  </template>
                  <template v-else>Не утилизировано</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
            <div class="item">
              <span class="caption">Информация о таможне: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.IsCustoms && info.Customs.length > 0">
                    <a
                      class="link"
                      href="#checkauto-customs">Показать</a>
                  </template>
                  <template v-else>Нет</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
            <div class="item">
              <span class="caption">Работа в условиях кр. севера: </span>
              <div class="value">
                <template v-if="full">
                  <template v-if="info.SpecialArea">Да</template>
                  <template v-else>Нет</template>
                </template>
                <template v-else>{{ offer }}</template>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div
        id="checkauto-data"
        class="section">
        <template v-if="!full">
          <div class="heading">
            <i class="icon">ℹ</i>
            Данные о ПТС
          </div>
          <div
            v-if="info.Count > 0"
            class="kit info text mini line">
            Количество рег. действий: {{ info.Count }}
          </div>
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p> Здесь указаны данные, которые занесены в информационную систему в ГИБДД,
            необходимо отметить, что фактическое количество регистрационных действий
            не всегда равно количеству записей в ПТС или количеству владельцев ТС.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-data'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <div class="heading">
            Данные о ПТС
            <button
              v-if="info.registration.length > 0 && !flag.showMap"
              @click="flag.showMap=true"
              class="ui button blue circular m-mini mobilshow">Смотреть на карте
            </button>
          </div>
          <template v-if="info.registration.length > 0">
            <div class="kit info text mini line desktopshow">
              Количество рег. действий: {{ info.registration.length }}
            </div>
            <div
              class="map"
              :class="{desktopshow:!flag.showMap}"
              id="mapPane">
              <no-ssr>
                <GmapMap
                  ref="mapRef"
                  :options="map.options"
                  :center.sync="map.center"
                  :zoom="map.zoom"
                  map-type-id="roadmap"
                  class="kit map full screen">
                  <GmapMarker
                    :key="m.locationHash"
                    v-for="m in map.markers"
                    :position="m.position"
                    :clickable="true"
                    :label="m.count > 1 ? String(m.count): ''"
                  />
                </GmapMap>
              </no-ssr>
            </div>

            <table
              id="pts-table"
              class="kit table cabinet bordered height-row-mini resize">
              <thead>
                <tr class="header small">
                  <th>
                    <div class="move-title">Дата</div>
                  </th>
                  <th>
                    <div class="move-title">Вид регистрации</div>
                  </th>
                  <th>
                    <div class="move-title">Владелец</div>
                  </th>
                  <th>
                    <div class="move-title">Область, Район, Населенный пункт</div>
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item in info.registration"
                  :key='item.id'>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Дата</div>
                      <div class="col">{{ item.dateOfLastOperation }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Вид регистрации</div>
                      <div class="col">{{ item.techOperation }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Владелец</div>
                      <div class="col">{{ item.fullOwner }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Область, Район, Населенный пункт</div>
                      <div
                        class="col"
                        :data-location="item.location"
                        :data-location-hash="item.locationHash">{{ item.location }}
                      </div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </template>
          <template v-else>
            {{ noData }}
          </template>
        </template>
      </div>
      <div
        id="checkauto-hijacking"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Угон
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Данные предоставлены ГИБДД, и актуальны только на время запроса.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-hijacking'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.Stealing">
            <table
              id="hijacking-table"
              class="kit table cabinet bordered height-row-mini resize">
              <thead>
                <tr class="header small">
                  <th>
                    <div class="move-title">Дата угона</div>
                  </th>
                  <th>
                    <div class="move-title">Страна</div>
                  </th>
                  <th>
                    <div class="move-title">Округ</div>
                  </th>
                  <th>
                    <div class="move-title">Область</div>
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item in info.stealing"
                  :key='item.id'>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Дата угона</div>
                      <div class="col">{{ item.date }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Страна</div>
                      <div class="col">
                        {{ item.countryName }}
                      </div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Округ</div>
                      <div class="col">{{ item.okrug }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Область</div>
                      <div class="col">{{ item.oblast }}</div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </template>
          <template v-else>
            <p class="no-data">Не в угоне</p>
          </template>
        </template>
      </div>

      <div
        id="checkauto-recycling"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Утилизация
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Информация по данным ГИБДД о нахождении автомобиля в реестре утилизированных.
            Выполнить регистрационные действия после утилизации нельзя.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-recycling'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.Utilisation">
            <table
              id="recycling-table"
              class="kit table cabinet bordered height-row-mini resize">
              <thead>
                <tr class="header small">
                  <th>
                    <div class="move-title">Дата утилизации</div>
                  </th>
                  <th>
                    <div class="move-title">Страна</div>
                  </th>
                  <th>
                    <div class="move-title">Утилизатор</div>
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item in info.utilisation"
                  :key='item.id'>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Дата утилизации</div>
                      <div class="col">{{ item.date }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Страна</div>
                      <div class="col">
                        {{ item.countryName }}
                      </div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Утилизатор</div>
                      <div class="col">{{ item.company }}</div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </template>
          <template v-else>
            <p class="no-data">Не утилизировано</p>
          </template>
        </template>
      </div>

      <div
        id="checkauto-leasing"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Лизинг
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Здесь указаны сведения о покупке ТС в лизинг. Обычно, в лизинг покупается
            коммерческий транспорт, либо легковой для организации парка такси.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-leasing'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.Leasing">
            <table
              id="leasing-table"
              class="kit table cabinet bordered height-row-mini resize">
              <thead>
                <tr class="header small">
                  <th>
                    <div class="move-title">Дата</div>
                  </th>
                  <th>
                    <div class="move-title">ИНН</div>
                  </th>
                  <th>
                    <div class="move-title">Организация</div>
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item in info.LeasingInformations"
                  :key='item.id'>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Дата</div>
                      <div class="col">{{ item.date }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">ИНН</div>
                      <div class="col">
                        {{ item.inn }}
                      </div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Организация</div>
                      <div class="col">{{ item.company }}</div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </template>
          <template v-else>
            <p class="no-data">Не в лизинге</p>
          </template>
        </template>
      </div>

      <div
        id="checkauto-accidents"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Аварии
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Данные предоставлены ГИБДД, и актуальны только на время запроса. При
            оформлении по Европротоколу информация в ГИБДД не поступает, также как при
            обоюдном соглашении о разрешении спора между участниками при отсутствии
            потерпевших.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-accidents'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.dtp.items.length > 0">
            <div class="subheading desktopshow">Информация о происшествиях</div>

            <div
              v-for="item in info.dtp.items"
              :key='item.id'
              class="chunk fluid spacing colorize">
              <div class="kit info text mini line">
                <div class="item">
                  <span class="caption">Происшествие:</span>
                  <span class="value">№ {{ item.number }}</span>
                </div>
                <div class="item">
                  <span class="caption">Дата:</span>
                  <span class="value">{{ item.date }}</span>
                </div>
                <div class="item">
                  <span class="caption">Тип происшествия:</span>
                  <span class="value">{{ item.type }}</span>
                </div>
                <div
                  class="item"
                  v-if="hasProp(item,'damageKind')">
                  <span class="caption">Степень повреждений:</span>
                  <span class="value">{{ item.damageKind }}</span>
                </div>
                <div class="item">
                  <span class="caption">Статус:</span>
                  <span class="value">{{ item.damageState }}</span>
                </div>
                <div class="item">
                  <span class="caption">Регион происшествия:</span>
                  <span class="value">{{ item.region }}</span>
                </div>
              </div>
              <div
                v-if="hasProp(item,'damagePointsMap')"
                class="kit crash block">
                <dtp-damage-map
                  :dtp-id="item.number"
                  :damages="item.damagePointsMap.split(' ')"/>
              </div>
            </div>

            <div
              v-if="info.dtp.hasPoints"
              class="chunk fluid spacing">
              <div class="kit marks block">
                <div class="marks">
                  <div class="mark yellow"/>
                  <div class="text">
                    Повреждения стекол, фар, указателей поворота, стоп-сигналов и других
                    стеклянных
                    элементов (в&nbsp;т.ч. зеркал), а&nbsp;также царапины, сколы,
                    потертости
                    лакокрасочного
                    покрытия или пластиковых конструктивных деталей и другие повреждения
                    без&nbsp;изменения
                    геометрии элементов (деталей) кузова и эксплуатационных
                    характеристик
                    ТС.
                  </div>
                </div>
                <div class="marks">
                  <div class="mark red"/>
                  <div class="text">
                    Вмятины, вырывы, заломы, перекосы, разрывы и другие повреждения с&nbsp;изменением
                    геометрии
                    элементов (деталей) кузова и эксплуатационных характеристик ТС.
                  </div>
                </div>
                <div class="marks">
                  <div class="mark cross"/>
                  <div class="text">
                    Повреждения различного характера
                  </div>
                </div>
              </div>
            </div>
          </template>
          <template v-else>
            <p class="no-data">Аварий не зафиксировано в системе</p>
          </template>
        </template>
      </div>

      <div
        id="checkauto-taxi"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Работа в такси
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Информация о работе в такси собирается по базам регистрации транспортных
            средств в качестве такси.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-taxi'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.Taxi">
            <table
              id="taxi-table"
              class="kit table cabinet bordered height-row-mini resize">
              <thead>
                <tr class="header small">
                  <th>
                    <div class="move-title">Дата</div>
                  </th>
                  <th>
                    <div class="move-title">ИНН</div>
                  </th>
                  <th>
                    <div class="move-title">Организация</div>
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr
                  v-for="item in info.TaxiInformations"
                  :key='item.id'>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Дата</div>
                      <div class="col">{{ item.date }}</div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">ИНН</div>
                      <div class="col">
                        {{ item.inn }}
                      </div>
                    </div>
                  </td>
                  <td>
                    <div class="move-row">
                      <div class="move-title">Организация</div>
                      <div class="col">{{ item.company }}</div>
                    </div>
                  </td>
                </tr>
              </tbody>
            </table>
          </template>
          <template v-else>
            <p class="no-data">Не использовалась в такси</p>
          </template>
        </template>
      </div>

      <div
        id="checkauto-customs"
        class="section">
        <div class="heading">
          <i
            v-if="!full"
            class="icon">ℹ</i>
          Таможня
        </div>
        <template v-if="!full">
          <div class="kit info text mini block color blue">
            <i class="icon">ℹ</i>
            <p>Данные, которые были заполнены в таможенных декларациях компанией, которая
            осуществляла ввоз транспортных средств на территорию РФ.
              <nuxt-link
                :to="{name:'check-auto-example', hash:'#checkauto-customs'}"
                class="link">
                Посмотреть пример
              </nuxt-link>
            </p>
          </div>
        </template>
        <template v-else>
          <template v-if="info.IsCustoms">
            <template v-for="item in info.Customs">
              <div
                :key='item.id'
                class="chunk">
                <div class="kit info text mini line">
                  <div class="item">
                    <span class="caption">Дата: </span>
                    <span class="value">{{ item.date }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Номер ГТД: </span>
                    <span class="value">{{ item.numberOfDeclaration }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Страна вывоза: </span>
                    <span class="value">{{ item.fromCountry }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Страна ввоза: </span>
                    <span class="value">{{ item.toCountry }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Организация: </span>
                    <span class="value">{{ item.company }}</span>
                  </div>
                </div>
              </div>
              <div
                class="chunk"
                :key='item.id'>
                <div class="kit info text mini line">
                  <div class="item">
                    <span class="caption">Цена: </span>
                    <span class="value">{{ item.statPrice }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Налог: </span>
                    <span class="value">{{ item.tax }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Цвет: </span>
                    <span class="value">{{ item.color }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Пробег: </span>
                    <span class="value">{{ item.mileage }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Экологический класс: </span>
                    <span class="value">{{ item.ecology }}</span>
                  </div>
                  <div class="item">
                    <span class="caption">Спецификация: </span>
                    <span class="value">{{ item.specification }}</span>
                  </div>
                </div>
              </div>
            </template>
          </template>
          <template v-else>
            <p class="no-data">Нет</p>
          </template>
        </template>
      </div>

      <div
        v-if="promo"
        class="section">
        <div class="kit info text mini block color yellow">
          <p>У вас есть <span class="kit text medium">промокод</span>?
            <span class="mobilshow"><br></span>
            <a
              href="#"
              class="link"
              @click.prevent="$emit('show-purchase')">Зарегистрируйтесь при покупке</a> или
            <a
              href="#"
              class="link"
              @click.prevent="showAuthModal">авторизуйтесь</a>,
              и&nbsp;получите&nbsp;скидку!
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>

import {
  has,
  forEach,
  keyBy,
  uniqBy,
  map,
  assign,
  pick,
} from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import DtpDamageMap from '~/components/check-auto/DtpDamageMap';
import NavReport from '~/components/check-auto/nav-report';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
export default {
  name: 'CheckAutoReport',
  components: {
    'dtp-damage-map': DtpDamageMap,
    NavReport,
  },
  filters: {
    def(value, defaultValue) {
      const def = defaultValue || '';
      if (!value) return def;
      return value;
    },
    currency(value) {
      return new Intl.NumberFormat('ru-RU', {
        style: 'decimal',
        currency: 'RUB',
        minimumFractionDigits: 0,
        maximumFractionDigits: 0,
      }).format(value);
    },
  },
  props: {
    info: {
      type: Object,
      required: true,
    },
    data: {
      type: Object,
      required: false,
      default: null,
    },
    full: {
      type: Boolean,
      required: true,
    },
    promo: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      noData: 'Нет данных',
      offer: 'Доступно в полном отчете',
      flag: {
        showMap: false,
      },
      map: {
        options: {
          mapTypeControl: false,
          streetViewControl: false,
          clickableIcons: false,
          rotateControl: false,
          fullscreenControl: false,
          disableDoubleClickZoom: true,
          minZoom: 3,
          maxZoom: 10,
        },
        center: {
          lat: 53.0,
          lng: 83.0,
        },
        zoom: 13,
        markers: [],
      },
      mapObj: null,

    };
  },
  computed: {
    regLocations() {
      let list = this.info.registration;
      list = map(list, o => assign(pick(o, ['location', 'locationHash']), { count: 0 }));
      list = uniqBy(list, 'locationHash');
      list = keyBy(list, 'locationHash');
      this.info.registration.forEach((item) => { list[item.locationHash].count += 1; });
      return list;
    },
  },
  mounted() {
    const self = this;
    if (this.full) {
      this.$nextTick(() => {
        this.$refs.mapRef.$mapPromise.then((mapObj) => {
          this.mapObj = mapObj;

          const geocoder = new window.google.maps.Geocoder();
          const bound = new window.google.maps.LatLngBounds();
          let count = Object.keys(this.regLocations).length;
          forEach(this.regLocations, (loc) => {
            geocoder.geocode({ address: loc.location }, (results, status) => {
              if (status === window.google.maps.GeocoderStatus.OK) {
                loc.position = results[0].geometry.location;
                self.map.markers.push(loc);
                bound.extend(loc.position);
              }
              count -= 1;
              if (count === 0) {
                mapObj.fitBounds(bound);
              }
            });
          });
        });
      });
    }
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
    hasProp(value, value2) {
      return has(value, value2);
    },
  },
};
</script>

<style scoped lang="postcss">
  .content {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: stretch;
    color: #4a4a4a;

    .chunk {
      flex: 0 1 50%;
      padding-right: 1rem;
      &.fluid {
        width: 100%;
        flex: 1 1 100%;
        padding-right: 0;
      }
      &.spacing {
        margin-top: 1.5rem;
      }
      @media screen and (max-width: 980px) {
        width: 100%;
        flex: 1 1 100%;
        padding: 0;
        margin: 0 !important;
        &.colorize {
          padding: 1rem 0.5rem;
          margin: 0 -0.5rem !important;
          &:nth-child(odd) {
            background-color: #f4f4f4;
          }
        }
      }
    }

    .kit.crash.block {
      width: 12.375rem;
      max-width: 12.375rem;
      height: auto;
      margin: 0 auto 0 0;
      @media screen and (max-width: 980px) {
        width: 100%;
        max-width: 80vw;
        margin: 1rem auto;
        height: auto;
        max-height: none;
        table.damageMap {
          width: 100%;
          max-width: 442px;
        }
      }
    }

    .kit.info.text.color {
      display: flex;
      justify-content: flex-start;
      align-items: center;
      flex-flow: row nowrap;
      width: 40rem;
      max-width: 100%;
      margin: 0;
      line-height: 1.5;
      color: #272727;
      p, span {
        font-size: inherit;
        line-height: inherit;
        color: inherit;
      }
      i.icon {
        flex: 0 0 1.5rem;
        display: block;
        width: 1.5rem;
        height: 1.5rem;
        margin-right: 0.75rem;
        font-size: 0;
        background-image: url("~assets/svg/icons/info-color-italic.svg");
        background-size: contain;
        background-position: center;
        background-repeat: no-repeat;
      }
      .link:hover {
        color: inherit;
      }
      @media screen and (max-width: 980px) {
        width: auto;
        max-width: none;
        margin: 0.25rem 0 0.5rem;
        font-size: 0.9375rem;
        line-height: 1.3;
        i.icon {
          display: none;
        }
      }
    }
    .kit.info.text:not(.color) {
      width: 100%;
      line-height: 1.5;
      > .item {
        white-space: normal;
        &.year-wrap {
          font-size: 0.9375rem;
          line-height: 1.3;
        }
      }
      @media screen and (max-width: 980px) {
        display: flex;
        flex-flow: column nowrap;
        justify-content: space-between;
        font-size: 0.875rem;
        line-height: 1.3;
        color: #383838;
        > .item {
          display: flex;
          margin-bottom: 0.625rem;
          &.year-wrap {
            justify-content: flex-start;
            * {
              width: auto;
              flex: 0 1 auto;
              font-weight: 400;
            }
          }
        }
      }
    }
    .kit.info.text .link {
      text-decoration: none;
      &:hover {
        text-decoration: underline;
      }
    }
    .kit.info.text .caption,
    .kit.info.text .value {
      color: inherit;
      line-height: inherit;
      @media screen and (max-width: 980px) {
        flex: 1 0 50%;
        width: 50%;
        white-space: normal;
      }
    }
    .kit.info.text .caption {
      font-weight: 500;
    }
    .kit.info.text .value {
      @media screen and (max-width: 980px) {
        display: block;
        padding-left: 0.5rem;
        word-wrap: break-word;
      }
    }

    .section.block.submenu {
      flex: 1 1 12.5rem;
      order: 2;
      display: flex;
      width: 12.5rem;
      margin-bottom: -8rem;
      background-color: #fbfbfb;
      border-left: 1px solid #dbe4e9;
    }

    .section.block.data {
      padding: 2.5rem 2.75rem 0.75rem;
      max-width: calc(100% - 12.5rem);
      order: 1;
      @media screen and (max-width: 980px) {
        max-width: 100%;
        padding: 0;
      }
    }

    .section:not(.block) {
      display: flex;
      flex-flow: row wrap;
      align-items: flex-start;
      width: 100%;
      border: none;
      margin-bottom: 2rem;
      &.bordered {
        @media only screen and (min-width: 981px) {
          padding-bottom: 2rem;
          border-bottom: 0.0625rem solid #c5d1d9;
        }
      }
      &.colorize {
        @media only screen and (max-width: 980px) {
          .kit.text.info {
            width: auto;
            padding: 1rem 0.5rem;
            margin: 0 -0.5rem !important;
            &:nth-child(even) {
              background-color: #f4f4f4;
            }
          }
        }
      }
      > .heading {
        display: block;
        width: 100%;
        padding-bottom: 0.625rem;
        font-size: 1rem;
        font-weight: 700;
        i.icon {
          display: inline-block;
          width: 1rem;
          height: 1rem;
          font-size: 0;
          color: #C5D1D9;
          background-image: url("~assets/svg/icons/info-italic.svg");
          background-size: contain;
          background-position: center;
          background-repeat: no-repeat;
          margin-right: .5rem;
          @media only screen and (min-width: 981px) {
            display: none;
          }
        }
        @media only screen and (max-width: 980px) {
          display: flex;
          flex-wrap: wrap;
          align-items: center;
          justify-content: flex-start;
          color: #4272a4;
          font-size: 1.125rem;
          font-weight: 500;
          padding: 0;
          margin-bottom: 0.75rem;
          > .ui.button {
            margin: 0.75rem 0 0.75rem auto;
            @media only screen and (max-width: 340px) {
              margin-left: 0;
            }
          }
        }
      }
      > .subheading {
        display: block;
        width: 100%;
        font-size: 0.875rem;
        font-weight: 500;
      }
      h2 {
        font-size: 1.3125rem;
        line-height: 1;
        margin: 0;
      }
      .no-data {
        font-size: 0.8175rem;
        @media only screen and (max-width: 980px) {
          font-size: 0.9375rem;
        }
      }
      > .map {
        width: 100%;
        height: 28rem;
        margin: 0.5rem 0 1rem;
        background-color: #a3ccff;
      }
    }
  }

  @media only screen and (min-width: 981px) {
    #pts-table {
      tr {
        th, td {
          &:nth-child(1) {
            width: auto;
            min-width: 5rem;
            max-width: 0;
            width: 100%;
          }
          &:nth-child(2) {
            width: auto;
            min-width: 10rem;
            max-width: 0;
          }
          &:nth-child(3) {
            width: auto;
            max-width: 0;
            min-width: 8rem;
          }
          &:nth-child(4) {
            width: auto;
            max-width: 0;
            min-width: 10rem;
          }
        }
      }
    }
    #hijacking-table {
      tr {
        th, td {
          &:nth-child(1), &:nth-child(2) {
            width: auto;
            min-width: 5rem;
            max-width: 0;
          }
          &:nth-child(3) {
            width: auto;
            min-width: 10rem;
            max-width: 0;
          }
          &:nth-child(4) {
            width: auto;
            max-width: 0;
            min-width: 7rem;
          }
          &:nth-child(5) {
            width: auto;
            max-width: 0;
            min-width: 7rem;
          }
        }
      }
    }
    #recycling-table,
    #taxi-table,
    #leasing-table {
      tr {
        th, td {
          &:nth-child(1) {
            width: 8rem;
            min-width: 5rem;
            max-width: 8rem;
          }
          &:nth-child(2) {
            width: auto;
            min-width: 10rem;
            max-width: 0;
          }
          &:nth-child(3) {
            width: auto;
            max-width: 0;
            min-width: 19rem;
          }
        }
      }
    }

  }
</style>
<style scoped lang="scss">
  .kit.map {
    &.full.screen {
      position: relative;
      height: 100%;
      width: 100%;
    }
  }
</style>
